#define codeVersion "Solar tracker 17.8.2014"

double runTime, cycleSeconds1, helloSunTime;
float sensorEast, sensorWest, Upv;

void setup() 
{
  Serial.begin(9600);
  Serial.println(codeVersion);
  Serial.println("pins:");
  Serial.println("A1 - Photovoltaic Voltage");
  Serial.println("A2 - sensor East");
  Serial.println("A3 - sensor West");
  Serial.println("D2 - output move East");
  digitalWrite(2,1); //1=Relay off
  pinMode(2, OUTPUT);
  Serial.println("D3 - output move West");
  digitalWrite(3,1); //1=Relay off
  pinMode(3, OUTPUT);
  helloSunTime=1800; // Start moving to East 30 minutes after power on
}

void loop()
{  
  runTime=millis()/1000;
  Upv=analogRead(A1)/49.2; // Photovoltaic Voltage
  if (Upv<8)
  {
    digitalWrite(2,1);
    helloSunTime=runTime+600; //Next move to East after 10 minutes
  }
  if (runTime>cycleSeconds1)
  {
    cycleSeconds1=runTime;
    sensorEast=sensorEast*.9+analogRead(A2)*.1;
    sensorWest=sensorWest*.9+analogRead(A3)*.1;

    if (runTime>helloSunTime && runTime<helloSunTime+300)
    {
      digitalWrite(2,0);  //Move to East Start
    }
    else
    {
      digitalWrite(2,1); //Move to east stop
      if (sensorWest<100 && sensorEast<100)
      {
        digitalWrite(3,1); //Move to west Stop
      }
      else
      {
        if (sensorWest-sensorEast>5) 
        {
          digitalWrite(3,0); //Move to West Start
          sensorEast=0;
          sensorWest=0;
        }
      }
    }

    Serial.print("A2: ");
    Serial.print(analogRead(A2));
    Serial.print(" => East sensor: ");
    Serial.print(sensorEast);
    Serial.print("   runTime: ");
    Serial.print(runTime, 0);
    Serial.print("   helloSunTime: ");
    Serial.println(helloSunTime, 0); 
    Serial.print("A3: ");
    Serial.print(analogRead(A3));
    Serial.print(" => West sensor: ");
    Serial.print(sensorWest);
    if (digitalRead(2) && digitalRead(3) ) Serial.print("   Motor stop");
    if (digitalRead(2)==0) Serial.print("   Motor moving to East");
    if (digitalRead(3)==0) Serial.print("   Motor moving to West");
    Serial.print("  Upv: ");
    Serial.println(Upv);
  }
}
